//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D404A0C036A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D404A0C036A.cm

//## begin module%3D404A0C036A.cp preserve=no
//## end module%3D404A0C036A.cp

//## Module: TableModParam%3D404A0C036A; Package body
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/TableModParam.cxx

//## begin module%3D404A0C036A.additionalIncludes preserve=no
//## end module%3D404A0C036A.additionalIncludes

//## begin module%3D404A0C036A.includes preserve=yes
//## end module%3D404A0C036A.includes

// ParamData
#include <XSModel/Parameter/ParamData.h>
// TableModParam
#include <XSModel/Parameter/TableModParam.h>
//## begin module%3D404A0C036A.declarations preserve=no
//## end module%3D404A0C036A.declarations

//## begin module%3D404A0C036A.additionalDeclarations preserve=yes
//## end module%3D404A0C036A.additionalDeclarations


// Class TableModParam 

TableModParam::TableModParam(const TableModParam &right)
  //## begin TableModParam::TableModParam%36C47EBDB700_copy.hasinit preserve=yes
      : ModParam(right), m_logInterp(right.m_logInterp), 
        m_numVals(right.m_numVals), m_tabValue(right.m_tabValue)
  //## end TableModParam::TableModParam%36C47EBDB700_copy.hasinit
  //## begin TableModParam::TableModParam%36C47EBDB700_copy.initialization preserve=yes
  //## end TableModParam::TableModParam%36C47EBDB700_copy.initialization
{
  //## begin TableModParam::TableModParam%36C47EBDB700_copy.body preserve=yes
  //## end TableModParam::TableModParam%36C47EBDB700_copy.body
}

TableModParam::TableModParam (const string& inputName, ComponentBase* p, Real val, Real delta, Real high, Real low, Real top, Real bot, const string& unit)
  //## begin TableModParam::TableModParam%383031EC6CC8.hasinit preserve=yes
      : ModParam(inputName,p,val,delta,high,low,top,bot,unit), m_logInterp(false),
        m_numVals(0),
        m_tabValue()
  //## end TableModParam::TableModParam%383031EC6CC8.hasinit
  //## begin TableModParam::TableModParam%383031EC6CC8.initialization preserve=yes
  //## end TableModParam::TableModParam%383031EC6CC8.initialization
{
  //## begin TableModParam::TableModParam%383031EC6CC8.body preserve=yes
  //## end TableModParam::TableModParam%383031EC6CC8.body
}


TableModParam::~TableModParam()
{
  //## begin TableModParam::~TableModParam%36C47EBDB700_dest.body preserve=yes
  //## end TableModParam::~TableModParam%36C47EBDB700_dest.body
}



//## Other Operations (implementation)
bool TableModParam::compare (const Parameter& right) const
{
  //## begin TableModParam::compare%3773EC517828.body preserve=yes
  const TableModParam& that = static_cast<const TableModParam&>(right);
  if ( !ModParam::compare(that) ) return false;
  if ( m_logInterp != that.m_logInterp ) return false;
  if ( m_numVals != that.m_numVals ) return false;
  size_t n = that.m_tabValue.size();
  if ( m_tabValue.size() != n )return false;
  std::valarray<bool> _test(m_tabValue != that.m_tabValue);
  for (size_t j = 0; j < n; ++j) if (_test[j]) return false;

  return true;  
  //## end TableModParam::compare%3773EC517828.body
}

TableModParam* TableModParam::clone (ComponentBase* p) const
{
  //## begin TableModParam::clone%3773E3982468.body preserve=yes
  TableModParam* cloned = new TableModParam(*this);
  cloned->parent(p);
  return cloned;  
  //## end TableModParam::clone%3773E3982468.body
}

// Additional Declarations
  //## begin TableModParam%36C47EBDB700.declarations preserve=yes
  //## end TableModParam%36C47EBDB700.declarations

//## begin module%3D404A0C036A.epilog preserve=yes
//## end module%3D404A0C036A.epilog
